\chapter{Object Orientation}\label{object-orientation}

{\LARGE O}bjects are  essential, programmatically.
It can be argued that a map or a dictionary can work perfectly well
instead of ``fully blown''  objects in multitude of languages. 

The idea of hiding states is bad, because it assumes
the incompetency of a programmer, rather all of them. 
A philosophy which assumes philosophers
are incompetent is contradictory onto itself. 

However, that is a philosophical debate, and is not needed to be played down.
There is no denial of facts, that modern computing world is object oriented.
Thus, ZoomBA has objects, even if we never intended it to have ``language specific'' objects in ZoomBA.

\begin{section}{Introduction to Classes}

\begin{subsection}{Defining and Creating}
\index{oop : def}
A class is defined by the keyword \emph{def} , just like a method definition.
The difference is, the method definition must have a $()$ after the keyword,
while the class definition does not. Thus :

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
def Hello{}
\end{lstlisting}  
\end{minipage}\end{center}

\index{oop : new()}
creates a class called \emph{Hello}.
Obviously one needs to create a class, that is created by the \emph{new()} function :

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
// reflection style creation 
h1 = new ( 'Hello' )
// hard coded creation, Hello resolves to current script
h2 = new ( Hello ) 
\end{lstlisting}  
\end{minipage}\end{center}
That is all it takes to create classes in ZoomBA. We sincerely thought about the Pythonic way
of resolving class name as the creation of new classes, and then decided to go against it.
In the pythonic way, it becomes impossible to tell, whether or not this is a class constructor call, 
or rather a generic function call. Observe this :

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
/* a function call or object creation? 
In ZoomBA, function call. In Python, anything! */
h = Hello() 
// clear object creation in ZoomBA
h = new ( Hello ) 
\end{lstlisting}  
\end{minipage}\end{center}

and this is why we do believe the Pythonic way is ambiguous.
The ZoomBA tenet of minimisation of code footprint must also abide by  the
tenet of maintainability. Moreover, ZoomBA is prototype based, hence none of the ZoomBA objects 
are actually a JVM class objects. They are, in the truest sense, dictionaries holding functions and properties.
\end{subsection}

\begin{subsection}{Instance Fields}
\index{ oop : fields }
Objects are property buckets. 
I choose to design ZoomBA precisely this way, the \href{http://www.w3schools.com/js/js_objects.asp}{JavaScript way}.
Pitfalls are obvious, and see a nice discussion \href{http://www.2ality.com/2012/01/objects-as-maps.html}{here}.
Those are not a problem for us here much, and subsequent discussion would show why.
In any case, object without any fields or rather say properties are meaningless objects.
Any object can be given any property at runtime. Observe the following :

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
// object creation in ZoomBA
h = new ( Hello ) 
h.greet_string = "hello, world" // create a field : greet_string
println( h.greet_string ) // access the field at runtime
\end{lstlisting}  
\end{minipage}\end{center}

Every field is public, and we are Pythonic. 
As the proverb goes  \emph{``Never design a tool for fools, while you were designing version 1.0, 
the fools upgraded themselves to version 2.0'' }. The Java naked field access without any getter 
and setter is 1.5 times faster than that of the getters and setters.

But we all agree that is a bad way of randomly assigning properties to an object.
Thus, we want to somewhat put properties inside the object in the time of creation. 

One easy way out is as follows:

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
def SomeClass : {  'a' : 42, b : false  }
 // now, instance is based on SomeClass
instance = new ( SomeClass )
\end{lstlisting}  
\end{minipage}\end{center}

One should also note that, both normal and string literals are allowed, 
much like JavaScript. This is the easiest way to create a prototype based object.
In the runtime, we can actually change the values, if we desire:

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
instance = new ( SomeClass ,  b = true )
// now a is 42, but b is true
\end{lstlisting}  
\end{minipage}\end{center}

But this is not what we really want. We want something which can programmatically initialize the instance, 
while it is being prepared. That is next.

\end{subsection}

\begin{subsection}{Constructor}
\index{ oop : constructor }
This brings to us the notion of constructor. There is no constructor
in ZoomBA, nothing actually constructs the class. There is obviously an instance initialiser.
This is defined as such :
\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
def Hello{
   def $$(){
      $.greet_string = 'Hello, World!'
   } 
}
h = new ( Hello )
println( h.greet_string )
\end{lstlisting}  
\end{minipage}\end{center}
\index{ oop : \$\$ } \index{ oop : \$ }
Now, this \emph{ \$\$() } is a specific function, which is the instance initialiser.
The special identifier \emph{\$} in the context in a class also is a specific identifier, identifying the instance
of the class being passed, this is pythons \emph{self}. One obviously can pass arguments
to the constructor :

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
def Hello{
   def $$(greetings='Hello, World'){
      $.greet_string = greetings
   } 
}
// the ordinary folks
h1 = new ( Hello )
println( h1.greet_string )
// from the Penguins of Madagascar
h2 = new ( Hello  , "Hey, Higher Mammal! Do you read?" )
println( h2.greet_string )
\end{lstlisting}  
\end{minipage}\end{center}
\end{subsection}

\begin{subsection}{Instance Methods}
\index{ oop : methods }
This brings the question of how do we \emph{encapsulate} the state of the object.
Sometimes, you do not want to let people access stuff. You want to handle
the properties of an instance yourself. Those are done with the instance methods,
constructor method is one special type of instance method:

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
def Hello{
   def $$(greetings='Hello, World'){
      $.greet_string = greetings
   } 
   def greet(){
      println( $.greet_string )
   }
}
h1 = new ( Hello )
h1.greet()
\end{lstlisting}  
\end{minipage}\end{center}
 
Obviously one can pass arguments to any instance method:

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
def Hello{
   def $$(greetings='Hello, World'){
      $.greet_string = greetings
   } 
   def greet(person="Everyone"){
      println( 'To @%s : %s\n', person ,  $.greet_string )
   }
}
h1 = new ( Hello )
h1.greet("ZoomBA")
\end{lstlisting}  
\end{minipage}\end{center}

\end{subsection}
\end{section}


\begin{section}{Statics \& Prototype Based Inheritence}

To have class level properties and methods, which gets initialised only once,
we must have \emph{static} constructs, which are indistinguishable from prototype.

\end{section}


\begin{section}{Operators}

ZoomBA supports operator overloading.
The following operators and functions can be overloaded :
\index{ oop : operator overloading}

\begin{center}
\begin{tabular}{| l | l | }
\hline
operator          & method       \\ \hline
toString          & \$str  \\
hashCode          & \$hc   \\
equals            & \$eq   \\
compareTo         & \$cmp  \\
+                 & \$add  \\
-                 & \$sub  \\
*                 & \$mult \\
/                 & \$div  \\
+=                 & \$add\$  \\
-=                 & \$sub\$  \\
*=                 & \$mult\$ \\
/=                 & \$div\$  \\
**                & \$pow  \\
unary -           & \$neg \\
|                 & \$or   \\
\&                & \$and  \\
\textasciicircum  & \$xor  \\ 
|=                 & \$or\$   \\
\&=                & \$and\$  \\
\textasciicircum=  & \$xor\$  \\ \hline
\end{tabular}
\end{center}


\begin{subsection}{Example : Complex Number}
As an example, we present the class Complex number, 
which overloads lots of operators :

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
def Complex {
    def $$ (x=0.0,y=0.0){
      $.x = Q(x)
      $.y = Q(y) 
    }
    def $str(){
      str('(%f,i %f)', $.x, $.y)
    }
    def $eq(o){
      ( $.x == o.x && $.y == o.y )
    }
    def $hc(){
       31 * $.x.hashCode() + $.y.hashCode()
    }
    def $neg(){
      new (Complex , -$.x , -$.y)
    }
    def $add(o){
      new (Complex , $.x + o.x , $.y + o.y )
    }
    def $sub(o){
      new (Complex , $.x - o.x , $.y - o.y )
    }
    def $mul(o){
      new (Complex , $.x * o.x  - $.y * o.y , $.x * o.y + $.y * o.x )
    }
    def $div(o){
      mod = ( o.x **2  + o.y **2 ) 
      x = ( $.x * o.x  + $.y * o.y )/mod 
      y = ( $.y * o.x  - $.x * o.y )/mod 
      new (Complex , x, y )
    }
}
// test it out :
c0 = new (Complex )
c12 = new (Complex , 1, 2)
c21 = new (Complex , 2, 1)
// test some?
println( -c12 )
println ( c0 == -c0 )
\end{lstlisting}  
\end{minipage}\end{center}

\end{subsection}
\end{section}
